#ifndef CAPCAP_H
#define CAPCAP_H

#include <linux/videodev2.h>

enum cc_io_method { IOM_USERPTR /*, IOM_MMAP, IOM_READ*/ };

typedef struct {
	char *fname;
	int fd;
	struct v4l2_capability cap;
	unsigned width;				// width in pixels
	unsigned height;			// height in pixels
	int stride;					// number of actual bytes per row
	unsigned imagesize; 		// image size in bytes
	unsigned pixelformat;		// e.g. V4L2_PIX_FMT_YUYV
	enum cc_io_method method;	// capture method
	void *vb;					// video buffer
} camcap_t;

typedef struct {
	// enum cc_io_method method <= if there are ever more than one
} camcap_open_t;

camcap_t *camcap_open(char *fname, camcap_open_t *co);
void camcap_get_sizes(camcap_t *cc, unsigned *width, unsigned *height, unsigned *bufsize);
int camcap_init(camcap_t *cc, void **vb);
int camcap_start_capturing(camcap_t *cc);
int camcap_read_frame(camcap_t *cc);
int camcap_requeue_frame(camcap_t *cc);
int camcap_stop_capturing(camcap_t *cc);
void camcap_close(camcap_t *cc);

// from camcap_arch_*
int camcap_scale(unsigned char *dst, int dwid, int dhgt, int dstride, unsigned char *src, int swid, int shgt, int sstride);

#endif
